/*
	File:		SCSIDriveIDSample.c

	Contains:	This sample shows how to convert from drive ID or volume name/id to the
 				associated SCSI Bus ID using both the old and new SCSI Managers.

	Written by: Martin Minow	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/14/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
#include <Folders.h>
#include <stdio.h>
#ifdef THINK_C
#include <console.h>
#endif

void					ShowAllDriveQueueElements(void);
void					ShowAllMountedVolumeNames(void);
void					ShowRegisteredSCSIDevices(void);
void					ShowSystemVolumeName(void);

void
main(
#ifdef THINK_C
		int					argc,
		char				**argv
#endif
	)
{
#ifdef THINK_C
		argc = ccommand(&argv);
#endif
		printf("*** System Volume Name ***\n");
		ShowSystemVolumeName();
		printf("*** Driver Queue Elements ***\n");
		ShowAllDriveQueueElements();
		printf("\n*** Mounted Volumes ***\n");
		ShowAllMountedVolumeNames();
		printf("\n*** Registered Devices ***\n");
		ShowRegisteredSCSIDevices();
}

